<?php

namespace DHLExpressGlobalWS\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Remark StructType
 * Meta information extracted from the WSDL
 * - documentation: Remark details
 * @subpackage Structs
 */
class Remark extends AbstractStructBase
{
    /**
     * The RemarkDescription
     * Meta information extracted from the WSDL
     * - documentation: Custom Invoice Remarks Description
     * - base: xsd:string
     * @var string
     */
    public $RemarkDescription;
    /**
     * Constructor method for Remark
     * @uses Remark::setRemarkDescription()
     * @param string $remarkDescription
     */
    public function __construct($remarkDescription = null)
    {
        $this
            ->setRemarkDescription($remarkDescription);
    }
    /**
     * Get RemarkDescription value
     * @return string|null
     */
    public function getRemarkDescription()
    {
        return $this->RemarkDescription;
    }
    /**
     * Set RemarkDescription value
     * @param string $remarkDescription
     * @return \DHLExpressGlobalWS\StructType\Remark
     */
    public function setRemarkDescription($remarkDescription = null)
    {
        // validation for constraint: string
        if (!is_null($remarkDescription) && !is_string($remarkDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($remarkDescription, true), gettype($remarkDescription)), __LINE__);
        }
        $this->RemarkDescription = $remarkDescription;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \DHLExpressGlobalWS\StructType\Remark
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
